{
  "info": "",
  "field": {
    "new_record": [
      ["inpa_invoice_id", "=", ["inv_invoice_id"]],
      ["inpa_invoice_payment_code", "=", ["inpa_invoice_id"]],
      ["inpa_payment_number", "=", [["Max", ["inpa_payment_number"]]], "+", "1"],
      ["inpa_arrival_date", "=", ["_date_Current", ["true"]]],
      ["inpa_payment_date", "=", ["inpa_arrival_date"]]
    ],
    "inpa_invoice_id": [
      ["inpa_scLASKU"]
    ],
    "inpa_is_partial_payment": [
      ["inpa_scON_OSASUORI"]
    ],
    "inpa_payment_date": [
      ["inpa_scMAKSUPAIVA"]
    ],
    "inpa_arrival_date": [
      ["inpa_scTULOPAIVA"]
    ],
    "inpa_payment": [
      ["inpa_scMAKSETTU_SU ----<>"]
    ],
    "inpa_method_of_payment": [
      ["inpa_scSUORITUSTAP ----<>"]
    ],
    "inpa_reference_number": [
      ["inpa_scVIITENUMERO ----<>"]
    ],
    "inpa_account_id": [
      ["inpa_scSUORITUSTIL ----<>"]
    ],
    "inpa_days_late": [
      ["inpa_scPAIVIA_MYOH"]
    ],
    "inpa_decrement_sum": [
      ["inpa_scVAHENNYS_SU ----<>"]
    ],
    "inpa_firm_id": [
      ["inpa_sYRITYS"]
    ]
  },
  "function": {
    "inpa_scLASKU": [
      ["inpa_reference_number", "=", ["inv_reference_number"]],
      ["inpa_customer", "=", ["inv_company_id"]],
      ["inpa_currency_id", "=", ["inv_currency_id"]],
      ["inpa_firm_id", "=", ["inv_firm_id"]],
      ["inpa_sYRITYS"],
      ["RELATE_ONE", ["inv_currency_id"]],
      ["inpa_exchange_rate", "=", ["cur_selling_rate"]],
      ["RELATE_ONE", ["inv_company_id"]],
      [
        "if", ["inv_coming_total", "<>", "0"],
        [
          [
            "if", ["inpa_payment", "=", "0"],
            [
              ["inpa_payment", "=", ["inv_coming_total"]],
              [
                "if", ["inpa_payment_date", ">", ["inv_due_date"]],
                [
                  ["inpa_days_late", "=", ["inpa_payment_date", "-", "inv_due_date"]],
                  ["inpa_KORKO_YHT"]
                ],
                "else",
                [
                  ["inpa_days_late", "=", "0"],
                  ["inpa_interest_total", "=", "0"]
                ]
              ]
            ]
          ],
          ["inpa_rSuoritus", "=", ["inpa_decrement_sum", "+", "inpa_payment"]],
          ["inpa_C_CURRENCY ----<>"]
        ],
        "else",
        [
          ["xCRY", ["Laskun_tulossa_oleva_summa_on_nolla."]]
        ]
      ]
    ],
    "inpa_scON_OSASUORI": [
      ["inpa_scMAKSETTU_S2"],
      ["inpa_KORKO_YHT"]
    ],
    "inpa_scMAKSETTU_S2": [
      ["inpa_scKURSSI2"],
      [
        "if", ["inv_exchange_rate", "=", "inpa_rKurssi"],
        [
          ["RELATE_ONE", ["inv_terms_of_payment_id"]],
          [
            "if", ["top_discount_days", ">", "0"],
            [
              [
                "if", [["Round", ["inpa_rKassaPro", "1"]], "=", ["top_discount_percentage"]],
                [
                  ["inpa_asVahLyh", "=", ["Find_in_array", ["inpa_asVahLyh", "KA"]]],
                  ["inpa_asVahTek", "=", ["inpa_asVahLyh"]]
                ]
              ]
            ]
          ]
        ]
      ]
    ],
    "inpa_scKURSSI2": [
      [
        "if", ["inv_exchange_rate", "<>", "inpa_rKurssi"],
        [
          [
            "if", ["inv_exchange_rate", "<>", "0"],
            [
              ["_r", "=", ["cur_C_Currency", ["true", "1", "inpa_rKurssi", "cur__DefaultCurre", "inpa_rTiliSumm", "inv_currency_id"]]],
              ["_r", "=", ["cur_C_Currency", ["true", "inv_exchange_rate", "1", "inv_currency_id", "_r", "cur__DefaultCurre"]]],
              [
                "if", ["false"],
                [
                  ["_r", "=", ["Round", [[["inpa_rTiliSumm", "/", "inpa_rKurssi"], "*", "inv_exchange_rate"], "2"]]]
                ]
              ]
            ],
            "else",
            [
              ["_r", "=", ["inpa_rTiliSumm"]]
            ]
          ],
          ["inpa_rJamasumm", "=", ["Round", [["_r", "-", "inpa_rTiliSumm"], "2"]]],
          ["inpa_asVahLyh", "=", ["Find_in_array", ["inpa_asVahLyh", "KE"]]],
          ["inpa_asVahTek", "=", ["inpa_asVahLyh"]]
        ],
        "else",
        [
          ["inpa_asVahLyh", "=", "1"],
          ["inpa_asVahTek", "=", "1"],
          [
            "if", ["inpa_rKokonais", "=", "1"],
            [
              [
                "if", ["inv_exchange_rate", "<>", "0"],
                [
                  ["_r", "=", ["cur_C_Currency", ["true", "1", "inv_exchange_rate", "cur__DefaultCurre", "inv_coming_total", "inv_currency_id"]]],
                  ["_r", "=", ["cur_C_Currency", ["true", "inpa_rKurssi", "1", "inv_currency_id", "_r", "cur__DefaultCurre"]]],
                  ["inpa_rJamasumm", "=", ["Round", [["_r", "-", "inpa_rTiliSumm"], "2"]]],
                  [
                    "if", ["false"],
                    [
                      ["inpa_rJamasumm", "=", ["Round", [[[["inv_coming_total", "/", "inv_exchange_rate"], "*", "inpa_rKurssi"], "-", "inpa_rTiliSumm"], "2"]]]
                    ]
                  ]
                ],
                "else",
                [
                  ["inpa_rJamasumm", "=", ["Round", [["inv_coming_total", "-", "inpa_rTiliSumm"], "2"]]]
                ]
              ]
            ],
            "else",
            [
              ["inpa_rJamasumm", "=", "0"]
            ]
          ]
        ]
      ],
      [
        "if", [["inpa_rJamasumm", "+", "inpa_rTiliSumm"], "<>", "0"],
        [
          ["inpa_rKassaPro", "=", [["inpa_rJamasumm", "/", ["inpa_rJamasumm", "+", "inpa_rTiliSumm"]], "*", "100"]]
        ],
        "else",
        [
          ["inpa_rKassaPro", "=", "0"]
        ]
      ]
    ],
    "inpa_KORKO_YHT": [
      [
        "if", ["inpa_days_late", ">", "0"],
        [
          [
            "if", ["g.inpa_lInterestDaysPerYear", ">", "0"],
            [
              [
                "if", ["inv_invoice_id", "<>", ["inpa_invoice_id"]],
                [
                  ["_sel_RELATE_ONE", ["inpa_invoice_id", "in_invoice_id"]]
                ]
              ],
              ["inpa_interest_total", "=", ["inpa_payment", "/", ["100", "*", "inv_penalty_interest"]]],
              ["inpa_interest_total", "=", ["Round", [["inpa_interest_total", "*", ["inpa_days_late", "/", ["g.inpa_lInterestDaysPerYear"]]], "2"]]]
            ],
            "else",
            [
              ["_err_MESSAGE", [["_lang_Current", ["Due_dates_in_year_is_zero"]], "inpa_KORKO_YHT", "true"]]
            ]
          ]
        ],
        "else",
        [
          ["inpa_interest_total", "=", "0"]
        ]
      ]
    ],
    "inpa_scMAKSUPAIVA": [
      [
        "if", ["inpa_arrival_date", "<", ["inpa_payment_date"]],
        [
          ["inpa_arrival_date", "=", ["inpa_payment_date"]]
        ]
      ],
      [
        "if", ["inpa_payment_date", ">", ["inv_due_date"]],
        [
          ["inpa_days_late", "=", ["inpa_payment_date", "-", "inv_due_date"]],
          ["inpa_KORKO_YHT"]
        ],
        "else",
        [
          ["inpa_days_late", "=", "0"],
          ["inpa_interest_total", "=", "0"]
        ]
      ]
    ],
    "inpa_scTULOPAIVA": [
      [
        "if", ["inpa_arrival_date", "<", ["inpa_payment_date"]],
        [
          ["xCRY", ["Tulopaiva_ei_voi_olla_pienempi_kuin_maksupaiva."]],
          ["inpa_arrival_date", "=", ["inpa_payment_date"]]
        ]
      ]
    ],
    "inpa_scMAKSETTU_SU": [
      ["inpa_scKURSSI"],
      [
        "if", ["inv_exchange_rate", "=", ["inpa_exchange_rate"]],
        [
          ["RELATE_ONE", ["inv_terms_of_payment_id"]],
          [
            "if", ["top_discount_days", ">", "0"],
            [
              [
                "if", [["Round", ["inpa_rKassaPro", "1"]], "=", ["top_discount_percentage"]],
                [
                  ["inpa_asVahLyh", "=", ["Find_in_array", ["inpa_asVahLyh", "KA"]]],
                  ["inpa_asVahTek", "=", ["inpa_asVahLyh"]],
                  ["inpa_decrement_type", "=", "KA"]
                ]
              ]
            ]
          ]
        ]
      ],
      ["inpa_rSuoritus", "=", ["inpa_decrement_sum", "+", "inpa_payment"]],
      ["inpa_C_CURRENCY ----<>"],
      ["inpa_KORKO_YHT"]
    ],
    "inpa_C_CURRENCY": [
      ["jatka tätä ---->"]
    ],
    "inpa_scKURSSI": [
      [
        "if", ["inv_exchange_rate", "<>", ["inpa_exchange_rate"]],
        [
          [
            "if", ["inpa_exchange_rate", "<>", "0"],
            [
              ["_r", "=", [["inpa_payment", "/", "inpa_exchange_rate"], "*", "inv_exchange_rate"]]
            ],
            "else",
            [
              ["_r", "=", ["inpa_payment"]]
            ]
          ],
          ["inpa_decrement_sum", "=", ["Round", [["_r", "-", "inpa_payment"], "2"]]],
          ["inpa_asVahLyh", "=", ["Find_in_array", ["inpa_asVahLyh", "KE"]]],
          ["inpa_asVahTek", "=", ["inpa_asVahLyh"]],
          [
            "if", ["inpa_asVahLyh", ">", "0"],
            [
              ["inpa_decrement_type", "=", "KE"]
            ]
          ]
        ],
        "else",
        [
          [
            "if", ["!inpa_is_partial_payment"],
            [
              [
                "if", ["inv_exchange_rate", "<>", "0"],
                [
                  ["_r", "=", ["cur_C_Currency", ["true", "1", "inv_exchange_rate", "cur__DefaultCurre", "inv_coming_total", "inv_currency_id"]]],
                  ["_r", "=", ["cur_C_Currency", ["true", "inpa_exchange_rate", "1", "inv_currency_id", "_r", "cur__DefaultCurre"]]],
                  ["inpa_decrement_sum", "=", ["_r", "-", "inpa_payment"]],
                  [
                    "if", ["false"],
                    [
                      ["inpa_decrement_sum", "=", ["Round", [[[["inv_coming_total", "/", "inv_exchange_rate"], "*", "inpa_exchange_rate"], "-", "inpa_payment"], "2"]]]
                    ]
                  ],
                  "else",
                  [
                    ["inpa_decrement_sum", "=", ["Round", [["inv_coming_total", "-", "inpa_payment"], "2"]]]
                  ]
                ]
              ]
            ],
            "else",
            [
              ["inpa_decrement_sum", "=", "0"]
            ]
          ]
        ]
      ],
      [
        "if", [["inpa_decrement_sum", "+", "inpa_payment"], "<>", "0"],
        [
          ["inpa_rKassaPro", "=", [["inpa_decrement_sum", "/", ["inpa_decrement_sum", "+", "inpa_payment"]], "*", "100"]]
        ],
        "else",
        [
          ["inpa_rKassaPro", "=", "0"]
        ]
      ]
    ],
    "inpa_scSUORITUSTAP": [
      ["_pop_FLD", ["0", "inpa_method_of_payment", "0"]],
      ["_inpa_lFound", "=", ["_qry_Fld", ["0", ["ac_name", "=", ["inpa_asSuorta[inpa_asSuorta]"]], "", "false"]]],
      [
        "if", ["_inpa_lFound", "<", "1"],
        [
          ["inpa_account_id", "=", ""],
          ["_err_CRY", ["concat", [["_lang_Current", ["Can't_find_record_from_table"]], ":", "ksSpace", "+", ["_tbl_Name", ["ac_tbl"]], "ksSpace", ["_lang_Current", ["where_name_is"]], "ksSpace", "inpa_asSuorta[inpa_asSuorta]", "true"]]]
        ],
        "elseif", ["_inpa_lFound", ">", "1"],
        [
          ["inpa_account_id", "=", ""],
          ["_err_CRY", ["concat", [["_lang_Current", ["Found_more_than_one_record_from_table"]], ":", "ksSpace", "+", ["_tbl_Name", ["ac_tbl"]], "ksSpace", ["_lang_Current", ["where_name_is"]], "ksSpace", "inpa_asSuorta[inpa_asSuorta]", "true"]]]
        ],
        "else",
        [
          ["inpa_account_id", "=", ["ac_account_id"]]
        ]
      ]
    ],
    "inpa_scVIITENUMERO": [
      [
        "if", ["inv_reference_number", "<>", ["inpa_reference_number"]],
        [
          ["QUERY", ["inv", ["inv_reference_number", "=", ["inpa_reference_number"]]]],
          [
            "if", [["Records_in_selection", ["inv"]], ">", "0"],
            [
              ["inpa_invoice_id", "=", ["inv_invoice_id"]],
              ["inpa_scLASKU"]
            ],
            "else",
            [
              ["inpa_invoice_id", "=", ""],
              ["RELATE_ONE", ["inpa_invoice_id"]],
              ["RELATE_ONE", ["inv_company_id"]],
              ["xCRY", ["Viitenumeroa_vastaavaa_laskua_ei_loytynyt."]],
              ["GOTO_OBJECT", ["inpa_reference_number"]]
            ]
          ]
        ]
      ]
    ],
    "inpa_scSUORITUSTIL": [
      ["_inpa_lFound", "=", ["Find_in_array", ["inpa_asSuorta", "ac_name"]]],
      [
        "if", ["_inpa_lFound", ">", "0"],
        [
          ["inpa_asSuorta", "=", ["_inpa_lFound"]],
          ["inpa_method_of_payment", "=", ["Substring", ["ac_name", "1", "25"]]]
        ],
        "else",
        [
          ["_err_MESSAGE", ["concat", [["_lang_Current", ["Can't_find_value_from_popup"]], ":", "ksSpace", ["_fld_Name", ["inpa_method_of_payment"]], "inpa_scSUORITUSTIL", "false"]]]
        ]
      ]
    ],
    "inpa_scPAIVIA_MYOH": [
      ["inpa_KORKO_YHT"]
    ],
    "inpa_scVAHENNYS_SU": [
      [
        "if", [["inpa_decrement_sum", "+", "inpa_payment"], "<>", "0"],
        [
          ["inpa_rKassaPro", "=", [["inpa_decrement_sum", "/", ["inpa_decrement_sum", "+", "inpa_payment"]], "*", "100"]],
          ["inpa_rSuoritus", "=", ["inpa_decrement_sum", "+", "inpa_payment"]],
          ["inpa_C_CURRENCY ----<>"]
        ],
        "else",
        [
          ["inpa_rKassaPro", "=", "0"]
        ]
      ]
    ],
    "inpa_sYRITYS": [
      ["inpa_NUMBER", ["g.aalNR_LOFF", "", "inpa_firm_id"]],
      ["inpa_scTUNNUS_NUM"]
    ],
    "inpa_scTUNNUS_NUM": [
      ["inpa_invoice_payment_code", "=", ["aaC_Nro_Tunnus", ["inpa_sS_MreEtu", "inpa_lTunNro", "inpa_lS_MrePit"]]]
    ]
  }
}
